dnl= ##########################################################################
dnl= # abiword-plugins: autogen.sh header
dnl= # this file is executed as a shell script
dnl= 
dnl= # 1. abi_plugin_macro is the name of the main macro defined here:
dnl= abi_plugin_macro="ABIPGN_ABICOMMAND"
dnl= 
dnl= # 2. abi_plugin_files is the list of files that configure must generate:
dnl= abi_plugin_files="GNUmakefile xp/GNUmakefile"
dnl= 
dnl= # 3. abi_plugin_desc is a short description of the plugin
dnl= abi_plugin_desc="Enables AbiWord to be used as a commanded daemon."
dnl= 
dnl= # 4. abi_plugin_enable - whether plugin should be enabled by default
dnl= abi_plugin_enable="yes"
dnl= 
dnl= return
dnl= ##########################################################################

AC_DEFUN([ABIPGN_ABICOMMAND],[

_abi_cppflags_save="$CPPFLAGS"
_abi_ldflags_save="$LDFLAGS"

ABI_COMMAND_CPPFLAGS=""
ABI_COMMAND_LDFLAGS=""

# Checks for libraries.
# Checks for header files.

have_readline=unknown
AC_CHECK_HEADER(readline/readline.h,[
	AC_CHECK_HEADER(readline/history.h,[
		AC_CHECK_LIB(readline,readline,[
			have_readline=yes
			LDFLAGS="-ltermcap $LDFLAGS"
			ABI_COMMAND_LDFLAGS="-ltermcap $ABI_COMMAND_LDFLAGS"
		],[	AC_CHECK_LIB(readline,rl_initialize,[
				have_readline=yes
				LDFLAGS="-lcurses $LDFLAGS"
				ABI_COMMAND_LDFLAGS="-lcurses $ABI_COMMAND_LDFLAGS"
			],have_readline=no,-lcurses)
		],-ltermcap)
	],have_readline=no)
],have_readline=no)

if [ test $have_readline != yes ]; then
	ABI_PLUGIN_REPORT([abicommand: error - readline libs or hdrs not found])
	abi_plugin_disable=yes
else
	ABI_COMMAND_LDFLAGS="-lreadline -lhistory $ABI_COMMAND_LDFLAGS"

	dnl only unix builds should need this stuff, so why...?
	ABI_GTK12(2)

	ABI_COMMAND_CPPFLAGS="$ABI_COMMAND_CPPFLAGS "`$abi_gtk_config --cflags`
	ABI_COMMAND_LDFLAGS="$ABI_COMMAND_LDFLAGS "`$abi_gtk_config --libs`

	ABI_PLUGIN_REPORT([abicommand: okay])
fi

AC_SUBST(ABI_COMMAND_CPPFLAGS)
AC_SUBST(ABI_COMMAND_LDFLAGS)

CPPFLAGS="$_abi_cppflags_save"
LDFLAGS="$_abi_ldflags_save"
])
dnl= ##########################################################################
dnl= # abiword-plugins: autogen.sh header
dnl= # this file is executed as a shell script
dnl= 
dnl= # 1. abi_plugin_macro is the name of the main macro defined here:
dnl= abi_plugin_macro="ABIPGN_AIKSAURUS"
dnl= 
dnl= # 2. abi_plugin_files is the list of files that configure must generate:
dnl= abi_plugin_files="GNUmakefile xp/GNUmakefile"
dnl= 
dnl= # 3. abi_plugin_desc is a short description of the plugin
dnl= abi_plugin_desc="Plugin to allow abiword to connect with AikSaurus."
dnl=
dnl= # 4. abi_plugin_enable - whether plugin should be enabled by default 
dnl= abi_plugin_enable="yes"
dnl=
dnl= return
dnl= ##########################################################################

AC_DEFUN([ABIPGN_AIKSAURUS],[

_abi_cppflags_save="$CPPFLAGS"
_abi_ldflags_save="$LDFLAGS"

ABI_AIKSAURUS_CPPFLAGS=""
ABI_AIKSAURUS_LDFLAGS=""

# Checks for libraries.
# Checks for header files.

AC_ARG_WITH(Aiksaurus,[  --with-Aiksaurus=DIR    Aiksaurus library in DIR],[
	if [ test "x$withval" = "xno" ]; then
		AC_MSG_ERROR([* * * Aiksaurus library required to build this plugin * * *])
	elif [ test "x$withval" != "xyes" ]; then
		ABI_AIKSAURUS_CPPFLAGS="-I$withval/include"
		ABI_AIKSAURUS_LDFLAGS="-L$withval/lib"
	fi
])

CPPFLAGS="$CPPFLAGS $ABI_AIKSAURUS_CPPFLAGS"
LDFLAGS="$LDFLAGS $ABI_AIKSAURUS_LDFLAGS"

AC_LANG_CPLUSPLUS
AC_CHECK_HEADER(Aiksaurus.h,[
	ABI_AIKSAURUS_LDFLAGS="-lAiksaurus $ABI_AIKSAURUS_LDFLAGS"
],[	ABI_PLUGIN_REPORT([aiksaurus: error - Aiksaurus.h not found])
	abi_plugin_disable=yes
])
AC_LANG_C

if test $abi_plugin_disable = no; then
	dnl other front ends will be possible eventually, but for the moment it's only GTK-1.2

	ABI_GTK12(2)
	ABI_AIKSAURUS_CPPFLAGS="$ABI_AIKSAURUS_CPPFLAGS `$abi_gtk_config --cflags`"
	ABI_AIKSAURUS_LDFLAGS="$ABI_AIKSAURUS_LDFLAGS `$abi_gtk_config --libs`"

	AC_LANG_CPLUSPLUS
	AC_CHECK_HEADER(AiksaurusGTK.h,[
		ABI_AIKSAURUS_LDFLAGS="-lAiksaurusGTK $ABI_AIKSAURUS_LDFLAGS"
	],[	ABI_PLUGIN_REPORT([aiksaurus: error - AiksaurusGTK.h not found])
		abi_plugin_disable=yes
	])
	AC_LANG_C
fi

if test $abi_plugin_disable = no; then
	ABI_PLUGIN_REPORT([aiksaurus: okay])
fi

AC_SUBST(ABI_AIKSAURUS_CPPFLAGS)
AC_SUBST(ABI_AIKSAURUS_LDFLAGS)

CPPFLAGS="$_abi_cppflags_save"
LDFLAGS="$_abi_ldflags_save"
])
dnl= ##########################################################################
dnl= # abiword-plugins: autogen.sh header
dnl= # this file is executed as a shell script
dnl= 
dnl= # 1. abi_plugin_macro is the name of the main macro defined here:
dnl= abi_plugin_macro="ABIPGN_GDICT"
dnl= 
dnl= # 2. abi_plugin_files is the list of files that configure must generate:
dnl= abi_plugin_files="GNUmakefile unix/GNUmakefile"
dnl= 
dnl= # 3. abi_plugin_desc is a short description of the plugin
dnl= abi_plugin_desc="Plugin to allow abiword to use gdict"
dnl=
dnl= # 4. abi_plugin_enable - whether plugin should be enabled by default 
dnl= abi_plugin_enable="yes"
dnl=
dnl= return
dnl= ##########################################################################

AC_DEFUN([ABIPGN_GDICT],[

_abi_cppflags_save="$CPPFLAGS"
_abi_ldflags_save="$LDFLAGS"

ABI_GDICT_CPPFLAGS=""
ABI_GDICT_LDFLAGS=""

# Checks for libraries.
# Checks for header files.

ABI_GNOME_OPT(1.2.13,yes)
if [ test $abi_gnome_opt = no ]; then
	ABI_GTK12(0)
	ABI_GDICT_CPPFLAGS="`$abi_gtk_config --cflags` -DUSE_FORK_AND_EXEC_METHOD=1"
	ABI_GDICT_LDFLAGS="`$abi_gtk_config --libs`"
	ABI_PLUGIN_REPORT([gdict: okay (no GNOME; using fork-and-exec method)])
else
	ABI_GDICT_CPPFLAGS="`$abi_gnome_config --cflags gnomeui gtk glib`"
	ABI_GDICT_LDFLAGS="`$abi_gnome_config --libs gnomeui gtk glib`"

	CPPFLAGS="$CPPFLAGS $ABI_GDICT_CPPFLAGS"
	LDFLAGS="$LDFLAGS $ABI_GDICT_LDFLAGS"

	have_libgdict=yes
	AC_CHECK_HEADER(libgdict/gdict-defbox.h,[
		AC_CHECK_LIB(gdict,gdict_defbox_lookup,have_libgdict=yes,[
			have_libgdict=no
			AC_MSG_WARN([* * * can't link against libgdict * * *])
		],$ABI_GDICT_LDFLAGS)
	],[	AC_MSG_WARN([* * * libgdict doesn't appear to be installed * * *])
		have_libgdict=no
	])

	if [ test $have_libgdict = no ]; then
		ABI_GTK12(0)
		ABI_GDICT_CPPFLAGS="`$abi_gtk_config --cflags` -DUSE_FORK_AND_EXEC_METHOD=1"
		ABI_GDICT_LDFLAGS="`$abi_gtk_config --libs`"
		ABI_PLUGIN_REPORT([gdict: okay (falling back to fork-and-exec method)])
	else
		ABI_GDICT_LDFLAGS="-lgdict $ABI_GDICT_LDFLAGS"
		ABI_PLUGIN_REPORT([gdict: okay (using libgdict)])
	fi
fi

AC_HEADER_SYS_WAIT
AC_CHECK_HEADERS([unistd.h])

# Checks for typedefs, structures, and compiler characteristics.
AC_TYPE_PID_T

# Checks for library functions.

AC_SUBST(ABI_GDICT_CPPFLAGS)
AC_SUBST(ABI_GDICT_LDFLAGS)

CPPFLAGS="$_abi_cppflags_save"
LDFLAGS="$_abi_ldflags_save"
])
dnl= ##########################################################################
dnl= # abiword-plugins: autogen.sh header
dnl= # this file is executed as a shell script
dnl= 
dnl= # 1. abi_plugin_macro is the name of the main macro defined here:
dnl= abi_plugin_macro="ABIPGN_ABIGDKPIXBUF"
dnl= 
dnl= # 2. abi_plugin_files is the list of files that configure must generate:
dnl= abi_plugin_files="GNUmakefile unix/GNUmakefile"
dnl= 
dnl= # 3. abi_plugin_desc is a short description of the plugin
dnl= abi_plugin_desc="Plugin to allow abiword to import several image types with gdk-pixbuf"
dnl=
dnl= # 4. abi_plugin_enable - whether plugin should be enabled by default 
dnl= abi_plugin_enable="yes"
dnl=
dnl= return
dnl= ##########################################################################

AC_DEFUN([ABIPGN_ABIGDKPIXBUF],[

_abi_cppflags_save="$CPPFLAGS"
_abi_ldflags_save="$LDFLAGS"

ABIGDKPIXBUF_CPPFLAGS=""
ABIGDKPIXBUF_LDFLAGS=""

# Checks for libraries.
# Checks for header files.

ABI_GDKPIXBUF_OPT(0.8.0,yes)
if [ test "$abi_gdkpixbuf_opt" = "no" ]; then
        ABI_PLUGIN_REPORT([AbiGdkPixbuf: error - gdkpixbuf >= 0.8.0 required])
	abi_plugin_disable=yes
else
	ABI_PLUGIN_REPORT([AbiGdkPixbuf: okay])
fi

if test $abi_plugin_disable = no; then
	ABIGDKPIXBUF_CPPFLAGS="$CPPFLAGS `$abi_gdkpixbuf_config --cflags`"
	ABIGDKPIXBUF_LDFLAGS="$LDFLAGS `$abi_gdkpixbuf_config --libs`"
fi

AC_SUBST(ABIGDKPIXBUF_CPPFLAGS)
AC_SUBST(ABIGDKPIXBUF_LDFLAGS)

CPPFLAGS="$_abi_cppflags_save"
LDFLAGS="$_abi_ldflags_save"
])
dnl= ##########################################################################
dnl= # abiword-plugins: autogen.sh header
dnl= # this file is executed as a shell script
dnl= 
dnl= # 1. abi_plugin_macro is the name of the main macro defined here:
dnl= abi_plugin_macro="ABIPGN_MAGICK"
dnl= 
dnl= # 2. abi_plugin_files is the list of files that configure must generate:
dnl= abi_plugin_files="GNUmakefile xp/GNUmakefile"
dnl= 
dnl= # 3. abi_plugin_desc is a short description of the plugin
dnl= abi_plugin_desc="Plugin to allow abiword to use imagemagick."
dnl=
dnl= # 4. abi_plugin_enable - whether plugin should be enabled by default 
dnl= abi_plugin_enable="yes"
dnl=
dnl= return
dnl= ##########################################################################

AC_DEFUN([ABIPGN_MAGICK],[

_abi_cppflags_save="$CPPFLAGS"
_abi_ldflags_save="$LDFLAGS"

ABI_MAGICK_CPPFLAGS=""
ABI_MAGICK_LDFLAGS=""

# Checks for libraries.
# Checks for header files.

ABI_MAGICKPP_OPT(5.4.0,yes)
if [ test "$abi_magickpp_opt" = "no" ]; then
        ABI_PLUGIN_REPORT([magick: error - Magick++ >= 5.4.0 not found])
	abi_plugin_disable=yes
else
	ABI_PLUGIN_REPORT([magick: okay])
fi

if test $abi_plugin_disable = no; then
	ABI_MAGICK_CPPFLAGS="`$abi_magickpp_config --cppflags`"
	ABI_MAGICK_LDFLAGS="`$abi_magickpp_config --ldflags` `$abi_magickpp_config --libs`"
fi

AC_SUBST(ABI_MAGICK_CPPFLAGS)
AC_SUBST(ABI_MAGICK_LDFLAGS)

CPPFLAGS="$_abi_cppflags_save"
LDFLAGS="$_abi_ldflags_save"
])
dnl= ##########################################################################
dnl= # abiword-plugins: autogen.sh header
dnl= # this file is executed as a shell script
dnl= 
dnl= # 1. abi_plugin_macro is the name of the main macro defined here:
dnl= abi_plugin_macro="ABIPGN_OPENWRITER"
dnl= 
dnl= # 2. abi_plugin_files is the list of files that configure must generate:
dnl= abi_plugin_files="GNUmakefile xp/GNUmakefile"
dnl= 
dnl= # 3. abi_plugin_desc is a short description of the plugin
dnl= abi_plugin_desc="Plugin to allow abiword to read/write OpenWriter and StarWriter documents"
dnl=
dnl= # 4. abi_plugin_enable - whether plugin should be enabled by default 
dnl= abi_plugin_enable="yes"
dnl=
dnl= return
dnl= ##########################################################################

AC_DEFUN([ABIPGN_OPENWRITER],[

_abi_cppflags_save="$CPPFLAGS"
_abi_ldflags_save="$LDFLAGS"

ABI_OPENWRITER_CPPFLAGS=""
ABI_OPENWRITER_LDFLAGS=""

# Checks for libraries.
# Checks for header files.

AC_ARG_WITH(zipios,[  --with-zipios=DIR       zipios++ library in DIR],[
	if [ test "x$withval" = "xno" ]; then
		AC_MSG_ERROR([* * * zipios++ library required to build this plugin * * *])
	elif [ test "x$withval" != "xyes" ]; then
		CPPFLAGS="$CPPFLAGS -I$withval/include"
		ABI_OPENWRITER_CPPFLAGS="-I$withval/include"
		ABI_OPENWRITER_LDFLAGS="-L$withval/lib"
	fi
])

AC_LANG_CPLUSPLUS

zipios_headers=yes
AC_CHECK_HEADER(zipios++/zipios-config.h,  ,zipios_headers=no)
AC_CHECK_HEADER(zipios++/zipfile.h,        ,zipios_headers=no)
AC_CHECK_HEADER(zipios++/meta-iostreams.h, ,zipios_headers=no)
AC_CHECK_HEADER(zipios++/fcollexceptions.h,,zipios_headers=no)
AC_CHECK_HEADER(zipios++/zipinputstream.h, ,zipios_headers=no)
AC_CHECK_HEADER(zipios++/zipoutputstream.h,,zipios_headers=no)
if [ test $zipios_headers = no ]; then
        ABI_PLUGIN_REPORT([OpenWriter: error - can't find zipios++ header(s)])
	abi_plugin_disable=yes
else
	ABI_PLUGIN_REPORT([OpenWriter: okay])
fi

AC_LANG_C

if test $abi_plugin_disable = no; then
	ABI_OPENWRITER_LDFLAGS="$ABI_OPENWRITER_LDFLAGS -lzipios -lz"
fi

AC_SUBST(ABI_OPENWRITER_CPPFLAGS)
AC_SUBST(ABI_OPENWRITER_LDFLAGS)

CPPFLAGS="$_abi_cppflags_save"
LDFLAGS="$_abi_ldflags_save"
])
dnl= ##########################################################################
dnl= # abiword-plugins: autogen.sh header
dnl= # this file is executed as a shell script
dnl= 
dnl= # 1. abi_plugin_macro is the name of the main macro defined here:
dnl= abi_plugin_macro="ABIPGN_BZ2ABW"
dnl= 
dnl= # 2. abi_plugin_files is the list of files that configure must generate:
dnl= abi_plugin_files="GNUmakefile xp/GNUmakefile"
dnl= 
dnl= # 3. abi_plugin_desc is a short description of the plugin
dnl= abi_plugin_desc="Plugin to allow abiword documents compressed with bzip2"
dnl=
dnl= # 4. abi_plugin_enable - whether plugin should be enabled by default 
dnl= abi_plugin_enable="yes"
dnl=
dnl= return
dnl= ##########################################################################

AC_DEFUN([ABIPGN_BZ2ABW],[

_abi_cppflags_save="$CPPFLAGS"
_abi_ldflags_save="$LDFLAGS"

BZ2ABW_CPPFLAGS=""
BZ2ABW_LDFLAGS=""

# Checks for libraries.
# Checks for header files.

ABI_BZIP2_OPT(yes)
if [ test "$abi_bzip2_opt" = "no" ]; then
        ABI_PLUGIN_REPORT([bz2abw: error - libbz2 not found])
	abi_plugin_disable=yes
else
	ABI_PLUGIN_REPORT([bz2abw: okay])
fi

if test $abi_plugin_disable = no; then
	BZ2ABW_CPPFLAGS="$abi_bzip2_cppflags"
	BZ2ABW_LDFLAGS="$abi_bzip2_ldflags $abi_bzip2_libs"
fi

AC_SUBST(BZ2ABW_CPPFLAGS)
AC_SUBST(BZ2ABW_LDFLAGS)

CPPFLAGS="$_abi_cppflags_save"
LDFLAGS="$_abi_ldflags_save"
])
dnl= ##########################################################################
dnl= # abiword-plugins: autogen.sh header
dnl= # this file is executed as a shell script
dnl= 
dnl= # 1. abi_plugin_macro is the name of the main macro defined here:
dnl= abi_plugin_macro="ABIPGN_HTML"
dnl= 
dnl= # 2. abi_plugin_files is the list of files that configure must generate:
dnl= abi_plugin_files="GNUmakefile xp/GNUmakefile"
dnl= 
dnl= # 3. abi_plugin_desc is a short description of the plugin
dnl= abi_plugin_desc="Plugin to enable import of arbitrary HTML documents"
dnl=
dnl= # 4. abi_plugin_enable - whether plugin should be enabled by default 
dnl= abi_plugin_enable="yes"
dnl=
dnl= return
dnl= ##########################################################################

AC_DEFUN([ABIPGN_HTML],[

_abi_cppflags_save="$CPPFLAGS"
_abi_ldflags_save="$LDFLAGS"

ABI_HTML_CPPFLAGS=""
ABI_HTML_LDFLAGS=""

# Checks for libraries.
# Checks for header files.

ABI_XML2_OPT(2.4.9,yes)
if [ test "$abi_xml2_opt" = "no" ]; then
	ABI_PLUGIN_REPORT([html: error - libxml2 >= 2.4.9 not found])
	abi_plugin_disable=yes
else
	ABI_PLUGIN_REPORT([html: okay])
fi

if test $abi_plugin_disable = no; then
	ABI_HTML_CPPFLAGS="`$abi_xml2_config --cflags` -DHAVE_LIBXML2"
	ABI_HTML_LDFLAGS="`$abi_xml2_config --libs`"
fi

AC_SUBST(ABI_HTML_CPPFLAGS)
AC_SUBST(ABI_HTML_LDFLAGS)

CPPFLAGS="$_abi_cppflags_save"
LDFLAGS="$_abi_ldflags_save"
])
dnl= ##########################################################################
dnl= # abiword-plugins: autogen.sh header
dnl= # this file is executed as a shell script
dnl= 
dnl= # 1. abi_plugin_macro is the name of the main macro defined here:
dnl= abi_plugin_macro="ABIPGN_SDW"
dnl= 
dnl= # 2. abi_plugin_files is the list of files that configure must generate:
dnl= abi_plugin_files="GNUmakefile xp/GNUmakefile"
dnl= 
dnl= # 3. abi_plugin_desc is a short description of the plugin
dnl= abi_plugin_desc=""
dnl=
dnl= # 4. abi_plugin_enable - whether plugin should be enabled by default 
dnl= abi_plugin_enable="yes"
dnl=
dnl= return
dnl= ##########################################################################

AC_DEFUN([ABIPGN_SDW],[

_abi_cppflags_save="$CPPFLAGS"
_abi_ldflags_save="$LDFLAGS"

ABI_SDW_CPPFLAGS=""
ABI_SDW_LDFLAGS=""

# Checks for libraries.
# Checks for header files.

abi_wv_source="$abi_plugin_source/../wv"

ABI_SDW_CPPFLAGS="-I$abi_wv_source"

if test $abi_plugin_disable = no; then
	ABI_GLIB12_OPT(0,yes)
	if [ test "$abi_glib_opt" = "no" ]; then
		ABI_PLUGIN_REPORT([sdw: okay (using wv's mini glib)])
		ABI_SDW_CPPFLAGS="-I$abi_wv_source/glib-wv $ABI_SDW_CPPFLAGS"
	else
		ABI_PLUGIN_REPORT([sdw: okay (using glib)])
		ABI_SDW_CPPFLAGS="`$abi_glib_config --cflags` $ABI_SDW_CPPFLAGS"
		ABI_SDW_LDFLAGS="`$abi_glib_config --libs`"
	fi
fi

AC_SUBST(ABI_SDW_CPPFLAGS)
AC_SUBST(ABI_SDW_LDFLAGS)

CPPFLAGS="$_abi_cppflags_save"
LDFLAGS="$_abi_ldflags_save"
])
